## android-file-transfer 3.9%2Bdfsg

=== CMakeLists.txt ===
project(android-file-transfer)

set (CMAKE_CXX_STANDARD 11)

set(VERSION_MAJOR "3")
set(VERSION_MINOR "9")
set(VERSION_PATCH "0")
set(VERSION_COUNT 3)
set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

message(STATUS "building for ${CMAKE_SYSTEM_NAME}")

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	set(USB_BACKEND_DARWIN TRUE)
endif()

cmake_minimum_required(VERSION 2.8)
set(CMAKE_USE_RELATIVE_PATHS TRUE)
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})

include(FindPkgConfig)
include(CheckFunctionExists)
include(CheckIncludeFiles)

find_package ( Threads )

option(BUILD_FUSE "Build fuse mount helper" ON)

if (BUILD_FUSE)
	pkg_check_modules ( FUSE fuse )
endif()

if (FUSE_FOUND)
	message(STATUS "fuse found, building mount helper")
	add_definitions(${FUSE_CFLAGS} -DFUSE_USE_VERSION=26)
endif()

check_include_files (magic.h HAVE_MAGIC_H)
check_library_exists(magic magic_open "" HAVE_LIBMAGIC)

if (HAVE_MAGIC_H AND HAVE_LIBMAGIC)
	message(STATUS "libmagic found")
	add_definitions(-DHAVE_LIBMAGIC)
	list(APPEND MTP_LIBRARIES magic)
	list(APPEND MTP_SHARED_LIBRARIES magic)
endif()

option(BUILD_QT_UI "Build reference Qt application" ON)
option(BUILD_SHARED_LIB "Build shared library" OFF)

option(USB_BACKEND_LIBUSB "Use libusb-1.0" OFF)
if (USB_BACKEND_LIBUSB)
	message(WARNING "WARNING! You're using libusb, this is known to be broken -- large memory consumption, violating kernel memory limits and bugs. Continue at your own risk")
endif()

add_definitions(-Wall -pthread)

if (NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE Release)
endif()

if (CMAKE_BUILD_TYPE STREQUAL Debug)
	add_definitions(-ggdb)
endif()

include_directories(. ${CMAKE_SOURCE_DIR})
include_directories(mtp/backend/posix)

set(SOURCES
	mtp/log.cpp
	mtp/ByteArray.cpp
	mtp/ptp/Device.cpp
	mtp/ptp/ObjectFormat.cpp
	mtp/ptp/PipePacketer.cpp
	mtp/ptp/Response.cpp
	mtp/ptp/Session.cpp

	mtp/usb/DeviceBusyException.cpp
	mtp/usb/BulkPipe.cpp
	mtp/usb/Request.cpp

	mtp/backend/posix/FileHandler.cpp
	mtp/backend/posix/Exception.cpp
)

exec_program(git ARGS describe --tags OUTPUT_VARIABLE AFT_VERSION RETURN_VALUE GIT_STATUS)
if (GIT_STATUS GREATER 0)
	file(READ ${CMAKE_SOURCE_DIR}/README.md README_MD)
	string(REGEX MATCH "version-([0-9a-fA-F.]+)-" _VERSION ${README_MD})
	set(AFT_VERSION "v${CMAKE_MATCH_1}-snapshot")
endif()
message(STATUS "version: ${AFT_VERSION}")

set(VERSION_SRC ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/version.cpp)
configure_file(mtp/version.cpp.in ${VERSION_SRC})

list(APPEND SOURCES ${VERSION_SRC})

if (USB_BACKEND_LIBUSB)

	pkg_check_modules(LIBUSB libusb-1.0 REQUIRED)
	include_directories(${LIBUSB_INCLUDE_DIRS})
	include_directories(mtp/backend/libusb)
	add_definitions(-DUSB_BACKEND_LIBUSB)

	list(APPEND SOURCES
		mtp/backend/libusb/usb/Context.cpp
		mtp/backend/libusb/usb/Device.cpp
		mtp/backend/libusb/usb/DeviceDescriptor.cpp
		mtp/backend/libusb/usb/Exception.cpp
	)
	list(APPEND MTP_LIBRARIES ${LIBUSB_LIBRARIES})
elseif (USB_BACKEND_DARWIN)
	find_library(CORE_LIBRARY CoreFoundation)
	find_library(IOKIT_LIBRARY IOKit)
	list(APPEND MTP_LIBRARIES ${IOKIT_LIBRARY} ${CORE_LIBRARY})
	include_directories(mtp/backend/darwin)
	list(APPEND SOURCES
		mtp/backend/darwin/usb/Context.cpp
		mtp/backend/darwin/usb/Device.cpp
		mtp/backend/darwin/usb/DeviceDescriptor.cpp
		mtp/backend/darwin/usb/Exception.cpp
		mtp/backend/darwin/usb/Interface.cpp
	)
else()
	include_directories(mtp/backend/linux)
	list(APPEND SOURCES
		mtp/backend/linux/usb/Endpoint.cpp
		mtp/backend/linux/usb/Context.cpp
		mtp/backend/linux/usb/Device.cpp
		mtp/backend/linux/usb/Interface.cpp
		mtp/backend/linux/usb/DeviceDescriptor.cpp
	)
endif()


if (BUILD_SHARED_LIB)
	add_library(mtp-ng SHARED ${SOURCES})
	set_target_properties(mtp-ng PROPERTIES SOVERSION ${VERSION})
	target_link_libraries(mtp-ng ${CMAKE_THREAD_LIBS_INIT} ${MTP_SHARED_LIBRARIES})

	if (USB_BACKEND_LIBUSB)
		target_link_libraries(mtp-ng ${LIBUSB_LIBRARIES})
	endif()

	list(INSERT MTP_LIBRARIES 0 mtp-ng)
	install(TARGETS mtp-ng LIBRARY DESTINATION "lib${LIB_SUFFIX}" ARCHIVE DESTINATION "lib${LIB_SUFFIX}")
else (BUILD_SHARED_LIB)
	add_library(mtp-ng-static STATIC ${SOURCES})
	target_link_libraries(mtp-ng-static ${MTP_LIBRARIES})
	list(INSERT MTP_LIBRARIES 0 mtp-ng-static)
	install(TARGETS mtp-ng-static LIBRARY DESTINATION "lib${LIB_SUFFIX}" ARCHIVE DESTINATION "lib${LIB_SUFFIX}")
endif (BUILD_SHARED_LIB)

add_definitions(-D_LARGEFILE_SOURCE=1 -D_FILE_OFFSET_BITS=64)

add_subdirectory(cli)

if (FUSE_FOUND)
	add_subdirectory(fuse)
endif()

if (BUILD_QT_UI)
	add_subdirectory(qt)
endif()

add_custom_target(uninstall COMMAND xargs rm < install_manifest.txt)

## android-file-transfer 3.2+git20180324

=== debian/changelog ===
android-file-transfer (3.2+git20180324-0~mx17) mx; urgency=medium

  * New upstream (continuous) release
  * Packaged for MX-17

 -- Timothy E. Harris <maintainer@mxrepo.com>  Thu, 29 Mar 2018 16:58:32 -0400

android-file-transfer (3.2-1~artful) artful; urgency=low

  * New upstream release

 -- Aleksey Samoilov <samoilov.lex@gmail.com>  Tue, 27 Jun 2017 17:17:34 +0900

android-file-transfer (3.2-1~sunderland93) unstable; urgency=medium

  * New upstream release

 -- Aleksey Samoilov <samoilov.lex@gmail.com>  Tue, 27 Jun 2017 17:14:41 +0900

android-file-transfer (3.0-6) unstable; urgency=medium

  * Rebuild for Ubuntu

 -- Aleksey Samoilov <samoilov.lex@gmail.com>  Sun, 04 Jun 2017 19:03:34 +0900

android-file-transfer (3.0-3) xenial; urgency=low

  * Rebuild for Ubuntu

 -- Aleksey Samoilov <samoilov.lex@gmail.com>  Sun, 04 Jun 2017 16:51:41 +0900

android-file-transfer (3.0-2) unstable; urgency=medium

  * Build for Debian
   * Add package with cli tool

 -- Aleksey Samoilov <samoilov.lex@gmail.com>  Sun, 04 Jun 2017 16:05:39 +0900

aftl (3.0-1) unstable; urgency=medium

  * New upstream release

 -- Aleksey Samoilov <samoilov.lex@gmail.com>  Fri, 12 Aug 2016 15:18:51 +0900

aftl (2.4-1) unstable; urgency=meduim

  * Better cli tool, with interactive mode, progress indicators and recursive upload/download support.
  * FUSE wrapper reconnects automatically, survives device reconnect.
  * Mac OS X support.
  * License changed to GPLv3.
  * Tweaks to build system, made qt/readline optional, appdata.xml added.
 
  
 -- Aleksey Samoilov <samoilov.lex@gmail.com>  Mon, 26 Oct 2015 19:44:05 +0900

=== debian/control ===
Source: android-file-transfer
Section: utils
Priority: optional
Maintainer: Aleksey Samoilov <samoilov.lex@gmail.com>
Build-Depends: debhelper (>= 9),
                              cmake,
                              qtbase5-dev,
                              libmagic-dev,
                              libfuse-dev
Standards-Version: 3.9.8
Homepage: https://github.com/whoozle/android-file-transfer-linux

Package: android-file-transfer
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: aftl-unstable, aftl
Replaces: aftl-unstable, aftl
Description: Android File Transfer for Linux (Qt client)
 Android File Transfer for Linux — reliable MTP client with minimalistic UI
 similar to Android File Transfer for Mac.
 It just works™.
 .
 This package contains Qt5 client
 
Package: aft-mtp-cli
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Android File Transfer for Linux
 Android File Transfer for Linux — reliable MTP client with minimalistic UI
 similar to Android File Transfer for Mac.
 It just works™.
 .
 This package contains the command line utility for mounting an MTP device
 as a FUSE filesystem.

=== debian/rules ===
#!/usr/bin/make -f

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/default.mk

export QT_SELECT := qt5

%:
	dh $@ --parallel

## android-file-transfer 3.9+dfsg

=== cli/CMakeLists.txt ===
find_package(Readline)
include(CheckCSourceCompiles)

set(CLI_SOURCES
	Command.cpp
	Session.cpp
	Tokenizer.cpp
	arg_lexer.l.cpp
	cli.cpp)

if (READLINE_FOUND)
	set(CMAKE_REQUIRED_LIBRARIES ${Readline_LIBRARY})
	set(READLINE_TEST_SRC "
#include <stdio.h>
#include <readline/readline.h>

int main(int argc, char **argv) {
	char *line = readline(\">\");
	return 0;
}
")
	check_c_source_compiles("${READLINE_TEST_SRC}" READLINE_NO_CURSES_TEST)
	if (NOT READLINE_NO_CURSES_TEST)
		message(STATUS "readline test failed - some systems expect you to link with termcap or curses libraries")
		message(STATUS "please find an example there: https://bugzilla.redhat.com/show_bug.cgi?id=499837")
		message(STATUS "trying to find and link curses library...")
#		set(CURSES_NEED_NCURSES TRUE)
		include(FindCurses)
		list(APPEND CMAKE_REQUIRED_LIBRARIES ${CURSES_LIBRARY})
		check_c_source_compiles("${READLINE_TEST_SRC}" READLINE_CURSES_TEST)
		if (READLINE_CURSES_TEST)
			list(APPEND Readline_LIBRARY ${CURSES_LIBRARIES})
		else()
			set(READLINE_FOUND FALSE) #disabling readline completely
		endif()
	endif()

	set(CMAKE_REQUIRED_LIBRARIES)
endif()

if (READLINE_FOUND)
	list(APPEND CLI_SOURCES CommandLine.cpp)
	list(APPEND CLI_LIBRARIES ${Readline_LIBRARY})
else()
	list(APPEND CLI_SOURCES CommandLineStub.cpp)
	message(WARNING "no readline library found, using stub")
endif()

add_executable(aft-mtp-cli ${CLI_SOURCES})
target_link_libraries(aft-mtp-cli ${MTP_LIBRARIES} ${CLI_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
install(TARGETS aft-mtp-cli RUNTIME DESTINATION bin)

=== fuse/CMakeLists.txt ===
add_executable(aft-mtp-mount fuse_ll.cpp)

target_link_libraries(aft-mtp-mount ${MTP_LIBRARIES} ${FUSE_LDFLAGS} ${CMAKE_THREAD_LIBS_INIT})
install(TARGETS aft-mtp-mount RUNTIME DESTINATION bin)

=== qt/CMakeLists.txt ===
project(mtp-qt)

if(DESIRED_QT_VERSION)
	if(DESIRED_QT_VERSION MATCHES 4)
		find_package(Qt4 QUIET)
	else()
		find_package(Qt5Widgets QUIET)
	endif()
else()
	find_package(Qt5Widgets QUIET)
	find_package(Qt4 QUIET)
endif()

set(SOURCES main.cpp
	mainwindow.cpp
	fileuploader.cpp
	commandqueue.cpp
	mtpobjectsmodel.cpp
	mtpstoragesmodel.cpp
	progressdialog.cpp
	createdirectorydialog.cpp
	renamedialog.cpp
	qtobjectstream.cpp
)

set(HEADERS mainwindow.h
	fileuploader.h
	commandqueue.h
	mtpobjectsmodel.h
	progressdialog.h
	createdirectorydialog.h
	renamedialog.h
	qtobjectstream.h
)

set(FORMS mainwindow.ui
	progressdialog.ui
	createdirectorydialog.ui
	renamedialog.ui
)

if (Qt5Widgets_FOUND)
	message(STATUS "Using Qt5")
	qt5_wrap_cpp(HEADERS_MOC ${HEADERS})
	qt5_wrap_ui(FORMS_HEADERS ${FORMS})
	qt5_add_resources(RESOURCES android-file-transfer.qrc)
	include_directories(${Qt5Widgets_INCLUDE_DIRS})
	set(EXTRA_QT_LINK ${Qt5Widgets_LIBRARIES})
elseif(Qt4_FOUND OR QT_FOUND OR QT4_FOUND)
	message(STATUS "Using Qt4")
	qt4_wrap_cpp(HEADERS_MOC ${HEADERS})
	qt4_wrap_ui(FORMS_HEADERS ${FORMS})
	qt4_add_resources(RESOURCES android-file-transfer.qrc)
	include(${QT_USE_FILE})
	set(EXTRA_QT_LINK ${QT_LIBRARIES})
else()
	message(WARNING "No Qt found")
	set(BUILD_QT_UI FALSE)
endif()

if (BUILD_QT_UI)
  set(APP_NAME "android-file-transfer")

  if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(MACOSX_BUNDLE_INFO_STRING "${APP_NAME} ${PROJECT_VERSION}")
    set(MACOSX_BUNDLE_BUNDLE_VERSION "${APP_NAME} ${PROJECT_VERSION}")
    set(MACOSX_BUNDLE_LONG_VERSION_STRING "${APP_NAME} ${PROJECT_VERSION}")
    set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}")
    set(MACOSX_BUNDLE_COPYRIGHT "2015-2018 Vladimir Menshakov")
    set(MACOSX_BUNDLE_ICON_FILE "android-file-transfer.icns")
    set(MACOSX_BUNDLE_GUI_IDENTIFIER "org.android-file-transfer")
    set(MACOSX_BUNDLE_BUNDLE_NAME "${APP_NAME}")
    set(MACOSX_BUNDLE_RESOURCES "${CMAKE_CURRENT_BINARY_DIR}/${APP_NAME}.app/Contents/Resources")
    execute_process(COMMAND ${CMAKE_COMMAND} -E make_directory ${MACOSX_BUNDLE_RESOURCES})

    set(APPLICATION_ICON ${CMAKE_CURRENT_SOURCE_DIR}/../osx/android-file-transfer.icns)
    set_source_files_properties(${APPLICATION_ICON} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
  else()
    set(APPLICATION_ICON "")
  endif()

  add_definitions(${QT_DEFINITIONS})
  include_directories(${CMAKE_CURRENT_BINARY_DIR})

  add_executable("${APP_NAME}" MACOSX_BUNDLE ${APPLICATION_ICON} ${SOURCES} ${HEADERS_MOC} ${FORMS_HEADERS} ${RESOURCES})
  target_link_libraries("${APP_NAME}" ${EXTRA_QT_LINK} ${MTP_LIBRARIES})

  install(TARGETS ${APP_NAME}
          RUNTIME DESTINATION bin
          BUNDLE DESTINATION .)

  if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    if (Qt5Widgets_FOUND)
      set(MACDEPLOYQT_TOOL ${Qt5Widgets_DIR}/../../../bin/macdeployqt)
    else()
      get_filename_component(QT_BIN_DIR ${QT_QMAKE_EXECUTABLE} PATH)
      set(MACDEPLOYQT_TOOL ${QT_BIN_DIR})
    endif()
    message(STATUS "Macdeployqt path: ${MACDEPLOYQT_TOOL}")
    install (CODE "
             message(STATUS \"Running deploy Qt tool: ${MACDEPLOYQT_TOOL}\")
             execute_process(COMMAND \"${MACDEPLOYQT_TOOL}\" ${CMAKE_INSTALL_PREFIX}/android-file-transfer.app ERROR_QUIET)
             execute_process(COMMAND \"${CMAKE_INSTALL_NAME_TOOL}\" -add_rpath @executable_path/../Frameworks \"${CMAKE_INSTALL_PREFIX}/${APP_NAME}.app/Contents/MacOS/${APP_NAME}\")
             " COMPONENT Runtime)
  else()
    install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/android-file-transfer.desktop DESTINATION share/applications)
    install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/android-file-transfer.appdata.xml DESTINATION share/metainfo)
    install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/android-file-transfer.png DESTINATION share/icons/hicolor/512x512/apps)
  endif()
endif()

=== debian/changelog ===
android-file-transfer (3.9+dfsg-1build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:09:36 +0100

android-file-transfer (3.9+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Remove upstream patch.
  * Bump Standards-Version to 4.4.0.

 -- Dylan Aïssi <daissi@debian.org>  Mon, 09 Sep 2019 21:33:30 +0200

android-file-transfer (3.7+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #928309)

 -- Dylan Aïssi <daissi@debian.org>  Wed, 01 May 2019 22:08:46 +0200

=== debian/control ===
Source: android-file-transfer
Maintainer: Dylan Aïssi <daissi@debian.org>
Section: misc
Priority: optional
Build-Depends: debhelper-compat (= 12),
               cmake,
               qtbase5-dev,
               libfuse-dev,
               libreadline-dev,
               pkg-config
Standards-Version: 4.4.0
Vcs-Browser: https://salsa.debian.org/daissi/android-file-transfer
Vcs-Git: https://salsa.debian.org/daissi/android-file-transfer.git
Homepage: https://whoozle.github.io/android-file-transfer-linux/

Package: android-file-transfer
Architecture: any
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: reliable MTP client with minimalistic UI
 Android-File-Transfer is a reliable MTP client with minimalistic UI.
 Its features are:
 1. Simple Qt UI with progress dialogs.
 2. FUSE wrapper, supporting partial read/writes, allowing instant access
      to your files.
 3. No file size limits.
 4. Automatically renames album cover to make it visible from media player.
 5. USB ‘Zerocopy’ support found in recent Linux kernel (no user/kernel
      data copying).
 6. No extra dependencies (e.g. libptp/libmtp).
 7. Available as static/shared library.
 8. Command line tool (aft-mtp-cli).

## android-file-transfer 4.2

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)
project(android-file-transfer)

set (CMAKE_CXX_STANDARD 11)

set(VERSION_MAJOR "4")
set(VERSION_MINOR "2")
set(VERSION_PATCH "0")
set(VERSION_COUNT 3)
set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")

message(STATUS "building for ${CMAKE_SYSTEM_NAME}")

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	set(USB_BACKEND_DARWIN TRUE)
	set(CMAKE_OSX_DEPLOYMENT_TARGET 10.13)
	find_program(OTOOL_BIN otool)
endif()

set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})

include(FindPkgConfig)
include(CheckFunctionExists)
include(CheckIncludeFiles)

find_package ( Threads )

option(BUILD_FUSE "Build fuse mount helper" ON)
option(BUILD_MTPZ "Build with MTPZ support" ON)
option(BUILD_PYTHON "Build python module" ON)
option(BUILD_TAGLIB "Build with taglib support" ON)

if (BUILD_PYTHON)
	find_package (Python COMPONENTS Interpreter Development QUIET)
endif()

if (BUILD_SHARED_LIB)
	set(LIB_NAME mtp-ng)
else()
	set(LIB_NAME mtp-ng-static)
endif()

if (BUILD_FUSE)
	pkg_check_modules ( FUSE fuse )
endif()

if (BUILD_TAGLIB)
	pkg_check_modules (TAGLIB taglib IMPORTED_TARGET)
	if (TAGLIB_FOUND)
		add_definitions(-DHAVE_TAGLIB=1)
	endif()
endif()

if (FUSE_FOUND)
	message(STATUS "fuse found, building mount helper")
	add_definitions(${FUSE_CFLAGS} -DFUSE_USE_VERSION=26)
endif()

if (PYTHON_FOUND)
	set(CMAKE_POSITION_INDEPENDENT_CODE ON)
	find_package(pybind11)
	if (NOT pybind11_FOUND)
		set(CMAKE_REQUIRED_INCLUDES ${Python_INCLUDE_DIRS})
		check_include_files("pybind11/pybind11.h" pybind11_FOUND LANGUAGE CXX)
		set(CMAKE_REQUIRED_INCLUDES)
	endif()
	if (pybind11_FOUND)
		add_subdirectory(python)
	else()
		message(WARNING "pybind11 not found, skipping python bindings")
	endif()
endif()

check_include_files (magic.h HAVE_MAGIC_H)
check_library_exists(magic magic_open "" HAVE_LIBMAGIC)

if (HAVE_MAGIC_H AND HAVE_LIBMAGIC)
	message(STATUS "libmagic found")
	add_definitions(-DHAVE_LIBMAGIC)
	list(APPEND MTP_LIBRARIES magic)
	list(APPEND MTP_SHARED_LIBRARIES magic)
endif()

option(BUILD_QT_UI "Build reference Qt application" ON)
option(BUILD_SHARED_LIB "Build shared library" OFF)

option(USB_BACKEND_LIBUSB "Use libusb-1.0" OFF)
if (USB_BACKEND_LIBUSB)
	message(WARNING "WARNING! You're using libusb, this is known to be broken -- large memory consumption, violating kernel memory limits and bugs. Continue at your own risk")
endif()

add_definitions(-Wall -pthread)
add_definitions(-D_LARGEFILE_SOURCE=1 -D_FILE_OFFSET_BITS=64)

if (NOT CMAKE_BUILD_TYPE)
	set(CMAKE_BUILD_TYPE Release)
endif()

if (CMAKE_BUILD_TYPE STREQUAL Debug)
	add_definitions(-ggdb)
endif()

set(SOURCES
	mtp/log.cpp
	mtp/ptp/DataTypeCode.cpp
	mtp/ptp/Device.cpp
	mtp/ptp/DeviceProperty.cpp
	mtp/ptp/Messages.cpp
	mtp/ptp/ObjectFormat.cpp
	mtp/ptp/ObjectProperty.cpp
	mtp/ptp/OperationCode.cpp
	mtp/ptp/PipePacketer.cpp
	mtp/ptp/Response.cpp
	mtp/ptp/Session.cpp

	mtp/usb/DeviceBusyException.cpp
	mtp/usb/BulkPipe.cpp
	mtp/usb/Request.cpp

	mtp/backend/posix/FileHandler.cpp
	mtp/backend/posix/Exception.cpp

	mtp/metadata/Metadata.cpp
	mtp/metadata/Library.cpp

	mtp/mtpz/TrustedApp.cpp
)

exec_program(git ARGS describe --tags --match='v*' OUTPUT_VARIABLE AFT_VERSION RETURN_VALUE GIT_STATUS)
if (GIT_STATUS EQUAL 0)
	string(REGEX MATCH "v([0-9a-fA-F.]+)-" _VERSION ${AFT_VERSION})
	set(AFT_BASE_VERSION ${CMAKE_MATCH_1})
else()
	file(READ ${CMAKE_SOURCE_DIR}/README.md README_MD)
	string(REGEX MATCH "version-([0-9a-fA-F.]+)-" _VERSION ${README_MD})
	set(AFT_BASE_VERSION ${CMAKE_MATCH_1})
	set(AFT_VERSION "v${AFT_BASE_VERSION}-snapshot")
endif()
message(STATUS "version: ${AFT_VERSION}, base version: ${AFT_BASE_VERSION}")

set(VERSION_SRC ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/version.cpp)
configure_file(mtp/version.cpp.in ${VERSION_SRC})

list(APPEND SOURCES ${VERSION_SRC})

if (USB_BACKEND_LIBUSB)
	pkg_check_modules(LIBUSB libusb-1.0 REQUIRED)
	add_definitions(-DUSB_BACKEND_LIBUSB)

	list(APPEND SOURCES
		mtp/backend/libusb/usb/Context.cpp
		mtp/backend/libusb/usb/Device.cpp
		mtp/backend/libusb/usb/DeviceDescriptor.cpp
		mtp/backend/libusb/usb/Exception.cpp
	)
	list(APPEND MTP_LIBRARIES ${LIBUSB_LIBRARIES})
elseif (USB_BACKEND_DARWIN)
	find_library(CORE_LIBRARY CoreFoundation)
	find_library(IOKIT_LIBRARY IOKit)
	list(APPEND MTP_LIBRARIES ${IOKIT_LIBRARY} ${CORE_LIBRARY})
	list(APPEND SOURCES
		mtp/backend/darwin/usb/Context.cpp
		mtp/backend/darwin/usb/Device.cpp
		mtp/backend/darwin/usb/DeviceDescriptor.cpp
		mtp/backend/darwin/usb/Exception.cpp
		mtp/backend/darwin/usb/Interface.cpp
	)
else()
	list(APPEND SOURCES
		mtp/backend/linux/usb/Endpoint.cpp
		mtp/backend/linux/usb/Context.cpp
		mtp/backend/linux/usb/Device.cpp
		mtp/backend/linux/usb/Interface.cpp
		mtp/backend/linux/usb/DeviceDescriptor.cpp
	)
endif()

#Always add TrustedApp to avoid polluting client code.
list(APPEND SOURCES
	mtp/mtpz/TrustedApp.cpp
)

if (BUILD_MTPZ)
	include(FindOpenSSL)
	if (OPENSSL_FOUND)
		set(_BUILD_MTPZ TRUE)
		message(STATUS "building with MTPZ support")
		add_definitions(-DMTPZ_ENABLED)
		list(APPEND MTP_LIBRARIES ${OPENSSL_CRYPTO_LIBRARY})
		list(APPEND MTP_SHARED_LIBRARIES ${OPENSSL_CRYPTO_LIBRARY})
	else()
		message(WARNING "building without MTPZ support, openssl not found")
	endif()
endif()

if (BUILD_SHARED_LIB)
	set(LIB_NAME mtp-ng)
else()
	set(LIB_NAME mtp-ng-static)
endif()

if (BUILD_SHARED_LIB)
	add_library(${LIB_NAME} SHARED ${SOURCES})
	set_target_properties(${LIB_NAME} PROPERTIES SOVERSION ${VERSION})
	target_link_libraries(${LIB_NAME} PRIVATE ${CMAKE_THREAD_LIBS_INIT} ${MTP_SHARED_LIBRARIES})

	if (USB_BACKEND_LIBUSB)
		target_link_libraries(${LIB_NAME} ${LIBUSB_LIBRARIES})
	endif()
else ()
	add_library(${LIB_NAME} STATIC ${SOURCES})
	target_link_libraries(${LIB_NAME} PRIVATE ${MTP_LIBRARIES})
endif ()

list(INSERT MTP_LIBRARIES 0 ${LIB_NAME})
install(TARGETS ${LIB_NAME} LIBRARY DESTINATION "lib${LIB_SUFFIX}" ARCHIVE DESTINATION "lib${LIB_SUFFIX}")
target_include_directories(${LIB_NAME} PUBLIC ${CMAKE_SOURCE_DIR} ${CMAKE_SOURCE_DIR}/mtp/backend/posix)

if (_BUILD_MTPZ)
	target_include_directories(${LIB_NAME} PRIVATE ${OPENSSL_INCLUDE_DIR})
endif()

if (TAGLIB_FOUND)
	target_include_directories(${LIB_NAME} PRIVATE ${TAGLIB_INCLUDE_DIRS})
	target_link_libraries(${LIB_NAME} PRIVATE PkgConfig::TAGLIB)
endif()

if (USB_BACKEND_LIBUSB)
	target_include_directories(${LIB_NAME} PUBLIC ${LIBUSB_INCLUDE_DIRS})
	target_include_directories(${LIB_NAME} PUBLIC mtp/backend/libusb)
elseif (USB_BACKEND_DARWIN)
	target_include_directories(${LIB_NAME} PUBLIC mtp/backend/darwin)
else()
	target_include_directories(${LIB_NAME} PUBLIC mtp/backend/linux)
endif()

if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	set(MACOSX_BUNDLE_LIBS)
	if (OPENSSL_FOUND)
		list(APPEND MACOSX_BUNDLE_LIBS /usr/local/opt/openssl@1.1/lib/libcrypto.1.1.dylib)
	endif()
	if (TAGLIB_FOUND)
		list(APPEND MACOSX_BUNDLE_LIBS /usr/local/opt/taglib/lib/libtag.1.dylib)
	endif()
	if (FUSE_FOUND)
		list(APPEND MACOSX_BUNDLE_LIBS /usr/local/lib/libosxfuse.2.dylib)
	endif()

	set(MACOSX_BUNDLE_LIBS_INSTALL)
	set(MACOSX_BUNDLE_ROOT_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_PROJECT_NAME}.app")
	message(STATUS "bundle root dir: ${MACOSX_BUNDLE_ROOT_DIR}")
endif()

add_subdirectory(cli)

if (FUSE_FOUND)
	add_subdirectory(fuse)
endif()

if (BUILD_QT_UI)
	add_subdirectory(qt)
endif()

add_custom_target(uninstall COMMAND xargs rm < install_manifest.txt)

=== cli/CMakeLists.txt ===
--- 
+++ 
@@ -9,6 +9,7 @@
 	cli.cpp)
 
 if (READLINE_FOUND)
+	set(CMAKE_REQUIRED_INCLUDES ${Readline_INCLUDE_DIR})
 	set(CMAKE_REQUIRED_LIBRARIES ${Readline_LIBRARY})
 	set(READLINE_TEST_SRC "
 #include <stdio.h>
@@ -35,6 +36,7 @@
 		endif()
 	endif()
 
+	set(CMAKE_REQUIRED_INCLUDES)
 	set(CMAKE_REQUIRED_LIBRARIES)
 endif()
 
@@ -47,5 +49,28 @@
 endif()
 
 add_executable(aft-mtp-cli ${CLI_SOURCES})
+target_include_directories(aft-mtp-cli SYSTEM PRIVATE ${Readline_INCLUDE_DIR})
 target_link_libraries(aft-mtp-cli ${MTP_LIBRARIES} ${CLI_LIBRARIES} ${CMAKE_THREAD_LIBS_INIT})
 install(TARGETS aft-mtp-cli RUNTIME DESTINATION bin)
+
+if (BUILD_QT_UI AND (${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
+	add_custom_command(TARGET aft-mtp-cli POST_BUILD COMMAND ${CMAKE_INSTALL_NAME_TOOL} -add_rpath "@executable_path/../../Frameworks/" $<TARGET_FILE:aft-mtp-cli>)
+	add_custom_command(TARGET aft-mtp-cli POST_BUILD COMMAND ${OTOOL_BIN} -L $<TARGET_FILE:aft-mtp-cli>)
+	set(AFT_MTP_CLI_PATH "${MACOSX_BUNDLE_ROOT_DIR}/Contents/SharedSupport/bin/aft-mtp-cli")
+	set(MACOSX_BUNDLE_LIBS_INSTALL "
+		${MACOSX_BUNDLE_LIBS_INSTALL}
+		file(INSTALL \"${CMAKE_CURRENT_BINARY_DIR}/aft-mtp-cli\" DESTINATION \"${MACOSX_BUNDLE_ROOT_DIR}/Contents/SharedSupport/bin\")
+	")
+	foreach(DYNLIB ${MACOSX_BUNDLE_LIBS})
+		get_filename_component(DYNLIB_NAME "${DYNLIB}" NAME)
+		set(MACOSX_BUNDLE_LIBS_INSTALL "
+			${MACOSX_BUNDLE_LIBS_INSTALL}
+			message(STATUS \"cli: fixing ${DYNLIB_NAME}\")
+			execute_process(COMMAND \"${CMAKE_INSTALL_NAME_TOOL}\" -change \"${DYNLIB}\" \"@executable_path/../../Frameworks/${DYNLIB_NAME}\" \"${AFT_MTP_CLI_PATH}\")
+		")
+	endforeach()
+	set(MACOSX_BUNDLE_LIBS_INSTALL "
+		${MACOSX_BUNDLE_LIBS_INSTALL}
+		execute_process(COMMAND \"${OTOOL_BIN}\" -L \"${AFT_MTP_CLI_PATH}\")
+	" PARENT_SCOPE)
+endif()

=== fuse/CMakeLists.txt ===
add_executable(aft-mtp-mount fuse_ll.cpp)

target_link_libraries(aft-mtp-mount ${MTP_LIBRARIES} ${FUSE_LDFLAGS} ${CMAKE_THREAD_LIBS_INIT})
install(TARGETS aft-mtp-mount RUNTIME DESTINATION bin)

if (BUILD_QT_UI AND (${CMAKE_SYSTEM_NAME} MATCHES "Darwin"))
	add_custom_command(TARGET aft-mtp-mount POST_BUILD COMMAND ${CMAKE_INSTALL_NAME_TOOL} -add_rpath "@executable_path/../../Frameworks/" $<TARGET_FILE:aft-mtp-mount>)
	add_custom_command(TARGET aft-mtp-mount POST_BUILD COMMAND ${OTOOL_BIN} -L $<TARGET_FILE:aft-mtp-mount>)
	set(AFT_MTP_MOUNT_PATH "${MACOSX_BUNDLE_ROOT_DIR}/Contents/SharedSupport/bin/aft-mtp-mount")
	set(MACOSX_BUNDLE_LIBS_INSTALL "
		${MACOSX_BUNDLE_LIBS_INSTALL}
		file(INSTALL \"${CMAKE_CURRENT_BINARY_DIR}/aft-mtp-mount\" DESTINATION \"${MACOSX_BUNDLE_ROOT_DIR}/Contents/SharedSupport/bin\")
	")
	foreach(DYNLIB ${MACOSX_BUNDLE_LIBS})
		get_filename_component(DYNLIB_NAME "${DYNLIB}" NAME)
		set(MACOSX_BUNDLE_LIBS_INSTALL "
			${MACOSX_BUNDLE_LIBS_INSTALL}
			message(STATUS \"fuse: fixing ${DYNLIB_NAME}\")
			execute_process(COMMAND \"${CMAKE_INSTALL_NAME_TOOL}\" -change \"${DYNLIB}\" \"@executable_path/../../Frameworks/${DYNLIB_NAME}\" \"${AFT_MTP_MOUNT_PATH}\")
			")
	endforeach()

	set(MACOSX_BUNDLE_LIBS_INSTALL "
		${MACOSX_BUNDLE_LIBS_INSTALL}
		execute_process(COMMAND \"${OTOOL_BIN}\" -L \"${AFT_MTP_MOUNT_PATH}\")
	" PARENT_SCOPE)

endif()

=== qt/CMakeLists.txt ===
if(DESIRED_QT_VERSION)
	if(DESIRED_QT_VERSION MATCHES 4)
		find_package(Qt4 QUIET)
	else()
		find_package(Qt5Widgets QUIET)
		find_package(Qt5Network QUIET)
		find_package(Qt5LinguistTools QUIET)
	endif()
else()
	find_package(Qt5Widgets QUIET)
	find_package(Qt5Network QUIET)
	find_package(Qt5LinguistTools QUIET)
	find_package(Qt4 QUIET)
endif()

set(SOURCES main.cpp
	mainwindow.cpp
	fileuploader.cpp
	commandqueue.cpp
	mtpobjectsmodel.cpp
	mtpstoragesmodel.cpp
	progressdialog.cpp
	createdirectorydialog.cpp
	renamedialog.cpp
	devicesdialog.cpp
	qtobjectstream.cpp
	utils.cpp
)

set(HEADERS mainwindow.h
	fileuploader.h
	commandqueue.h
	mtpobjectsmodel.h
	progressdialog.h
	createdirectorydialog.h
	renamedialog.h
	devicesdialog.h
	qtobjectstream.h
)

set(FORMS mainwindow.ui
	progressdialog.ui
	createdirectorydialog.ui
	renamedialog.ui
	devicesdialog.ui
)

set(TS_FILES
	translations/android-file-transfer-linux_cs.ts
	translations/android-file-transfer-linux_it.ts
	translations/android-file-transfer-linux_nl.ts
	translations/android-file-transfer-linux_ru.ts
)

if (Qt5Widgets_FOUND)
	message(STATUS "Using Qt5")
	qt5_wrap_cpp(HEADERS_MOC ${HEADERS})
	qt5_wrap_ui(FORMS_HEADERS ${FORMS})

	qt5_add_translation(QM_FILES ${TS_FILES})
	set(QM_FILES_XML "")
	foreach(_QM ${QM_FILES})
		get_filename_component(_QM ${_QM} NAME)
		set(QM_FILES_XML "${QM_FILES_XML}<file>${_QM}</file>")
	endforeach()
	configure_file(translations/translations.qrc.in translations.qrc)

	qt5_add_resources(RESOURCES android-file-transfer.qrc ${CMAKE_CURRENT_BINARY_DIR}/translations.qrc)
	include_directories(${Qt5Widgets_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS})
	set(EXTRA_QT_LINK ${Qt5Widgets_LIBRARIES} ${Qt5Network_LIBRARIES})
elseif(Qt4_FOUND OR QT_FOUND OR QT4_FOUND)
	message(STATUS "Using Qt4")
	qt4_wrap_cpp(HEADERS_MOC ${HEADERS})
	qt4_wrap_ui(FORMS_HEADERS ${FORMS})

	qt4_add_translation(QM_FILES ${TS_FILES})
	set(QM_FILES_XML "")
	foreach(_QM ${QM_FILES})
		get_filename_component(_QM ${_QM} NAME)
		set(QM_FILES_XML "${QM_FILES_XML}<file>${_QM}</file>")
	endforeach()
	configure_file(translations/translations.qrc.in translations.qrc)

	qt4_add_resources(RESOURCES android-file-transfer.qrc ${CMAKE_CURRENT_BINARY_DIR}/translations.qrc)
	include(${QT_USE_FILE})
	set(EXTRA_QT_LINK Qt4::QtNetwork ${QT_LIBRARIES})
else()
	message(WARNING "No Qt found")
	set(BUILD_QT_UI FALSE)
endif()

if (BUILD_MTPZ)
	set(MTPZ_DATA_SOURCE "\"https://raw.githubusercontent.com/kbhomes/libmtp-zune/master/src/.mtpz-data\"")
	add_definitions(-DMTPZ_DATA_SOURCE=${MTPZ_DATA_SOURCE})
endif()

if (BUILD_QT_UI)
  if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	set(MACOSX_BUNDLE_INFO_STRING "${CMAKE_PROJECT_NAME} ${PROJECT_VERSION}")
	set(MACOSX_BUNDLE_BUNDLE_VERSION "${AFT_BASE_VERSION}")
	set(MACOSX_BUNDLE_LONG_VERSION_STRING "${CMAKE_PROJECT_NAME} ${PROJECT_VERSION}")
	set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}")
	set(MACOSX_BUNDLE_COPYRIGHT "2015-2020 Vladimir Menshakov")
	set(MACOSX_BUNDLE_ICON_FILE "android-file-transfer.icns")
	set(MACOSX_BUNDLE_GUI_IDENTIFIER "io.github.whoozle.android-file-transfer-linux")
	set(MACOSX_BUNDLE_BUNDLE_NAME "${CMAKE_PROJECT_NAME}")
	set(MACOSX_BUNDLE_EXECUTABLE_NAME "${CMAKE_PROJECT_NAME}")
	set(MACOSX_BUNDLE_RESOURCES "${CMAKE_CURRENT_BINARY_DIR}/${CMAKE_PROJECT_NAME}.app/Contents/Resources")
	execute_process(COMMAND ${CMAKE_COMMAND} -E make_directory ${MACOSX_BUNDLE_RESOURCES})
	set(MACOSX_BUNDLE_INFO_PLIST ${CMAKE_CURRENT_BINARY_DIR}/Info.plist)
	message(STATUS "generated bundle info is in ${MACOSX_BUNDLE_INFO_PLIST}")
	configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Info.plist.in ${MACOSX_BUNDLE_INFO_PLIST})

	set(APPLICATION_ICON ${CMAKE_SOURCE_DIR}/osx/android-file-transfer.icns)
	set_source_files_properties(${APPLICATION_ICON} PROPERTIES MACOSX_PACKAGE_LOCATION "Resources")
  else()
	set(APPLICATION_ICON "")
  endif()

  add_definitions(${QT_DEFINITIONS})
  include_directories(${CMAKE_CURRENT_BINARY_DIR})

  add_executable("${CMAKE_PROJECT_NAME}" MACOSX_BUNDLE ${APPLICATION_ICON} ${SOURCES} ${HEADERS_MOC} ${FORMS_HEADERS} ${RESOURCES})
  set_property(TARGET ${CMAKE_PROJECT_NAME} PROPERTY MACOSX_BUNDLE_INFO_PLIST "${MACOSX_BUNDLE_INFO_PLIST}")
  target_link_libraries("${CMAKE_PROJECT_NAME}" ${EXTRA_QT_LINK} ${MTP_LIBRARIES})

  install(TARGETS ${CMAKE_PROJECT_NAME}
		  RUNTIME DESTINATION bin
		  BUNDLE DESTINATION .)

  if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
	set(MACOSX_BUNDLE_APP_PATH "${MACOSX_BUNDLE_ROOT_DIR}/Contents/MacOS/${CMAKE_PROJECT_NAME}")

	add_custom_command(TARGET ${CMAKE_PROJECT_NAME} POST_BUILD
		COMMAND ${OTOOL_BIN} -L "$<TARGET_FILE:${CMAKE_PROJECT_NAME}>"
	)
	if (Qt5Widgets_FOUND)
	  set(MACDEPLOYQT_TOOL ${Qt5Widgets_DIR}/../../../bin/macdeployqt)
	else()
	  get_filename_component(QT_BIN_DIR ${QT_QMAKE_EXECUTABLE} PATH)
	  set(MACDEPLOYQT_TOOL ${QT_BIN_DIR})
	endif()
	message(STATUS "Macdeployqt path: ${MACDEPLOYQT_TOOL}")

	if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
		add_custom_command(TARGET ${CMAKE_PROJECT_NAME} POST_BUILD COMMAND ${CMAKE_INSTALL_NAME_TOOL} -add_rpath "@executable_path/../Frameworks/" $<TARGET_FILE:${CMAKE_PROJECT_NAME}>)
		set(MACOSX_BUNDLE_LIBS_PRE_INSTALL)
		foreach(DYNLIB ${MACOSX_BUNDLE_LIBS})
			message(STATUS "additional bundle lib ${DYNLIB}")
			get_filename_component(DYNLIB_NAME "${DYNLIB}" NAME)
			set(MACOSX_BUNDLE_LIBS_PRE_INSTALL "
				${MACOSX_BUNDLE_LIBS_PRE_INSTALL}
				file(INSTALL \"${DYNLIB}\" DESTINATION \"${MACOSX_BUNDLE_ROOT_DIR}/Contents/Frameworks\" FOLLOW_SYMLINK_CHAIN)
				message(STATUS \"qt: fixing ${DYNLIB_NAME}\")
				execute_process(COMMAND \"${CMAKE_INSTALL_NAME_TOOL}\" -change \"${DYNLIB_NAME}\" \"@executable_path/../Frameworks/${DYNLIB_NAME}\" \"${MACOSX_BUNDLE_APP_PATH}\")
			")
		endforeach()
	endif()

	install (CODE "
			 message(STATUS \"Running deploy Qt tool: ${MACDEPLOYQT_TOOL}\")
			 execute_process(COMMAND \"${MACDEPLOYQT_TOOL}\" ${MACOSX_BUNDLE_ROOT_DIR})
			 ${MACOSX_BUNDLE_LIBS_PRE_INSTALL}
			 ${MACOSX_BUNDLE_LIBS_INSTALL}
			 execute_process(COMMAND \"${OTOOL_BIN}\" -L \"${MACOSX_BUNDLE_APP_PATH}\")
			 " COMPONENT Runtime)
  else()
	install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/android-file-transfer.desktop DESTINATION share/applications)
	install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/android-file-transfer.appdata.xml DESTINATION share/metainfo)
	install (FILES ${CMAKE_CURRENT_SOURCE_DIR}/android-file-transfer.png DESTINATION share/icons/hicolor/512x512/apps)
  endif()
endif()

=== debian/changelog ===
android-file-transfer (4.2-1) unstable; urgency=medium

  * Update VCS fields to point to the Debian namespace on salsa.
  * New upstream version
  * Standards-Version: 4.5.1 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Add qttools5-dev to BD

 -- Dylan Aïssi <daissi@debian.org>  Tue, 02 Feb 2021 17:38:41 +0100

=== debian/control ===
--- 
+++ 
@@ -2,16 +2,18 @@
 Maintainer: Dylan Aïssi <daissi@debian.org>
 Section: misc
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                cmake,
                qtbase5-dev,
                libfuse-dev,
                libreadline-dev,
-               pkg-config
-Standards-Version: 4.4.0
-Vcs-Browser: https://salsa.debian.org/daissi/android-file-transfer
-Vcs-Git: https://salsa.debian.org/daissi/android-file-transfer.git
+               pkg-config,
+               qttools5-dev
+Standards-Version: 4.5.1
+Vcs-Browser: https://salsa.debian.org/debian/android-file-transfer
+Vcs-Git: https://salsa.debian.org/debian/android-file-transfer.git
 Homepage: https://whoozle.github.io/android-file-transfer-linux/
+Rules-Requires-Root: no
 
 Package: android-file-transfer
 Architecture: any

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export QT_SELECT=qt5

%:
	dh $@

override_dh_auto_install:
	dh_auto_install
	# Removing unused files
	rm -f debian/android-file-transfer/usr/lib/libmtp-ng-static.a
	find debian/android-file-transfer/ -type d -empty -delete

=== debian/watch ===
version=4
opts=repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz,\
  filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/android-file-transfer-linux-$1\.tar\.gz/ \
  https://github.com/whoozle/android-file-transfer-linux/tags .*/v?(\d\S+)\.tar\.gz

## android-file-transfer 4.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,10 +1,10 @@
-cmake_minimum_required(VERSION 2.8.12)
+cmake_minimum_required(VERSION 3.5)
 project(android-file-transfer)
 
 set (CMAKE_CXX_STANDARD 11)
 
 set(VERSION_MAJOR "4")
-set(VERSION_MINOR "2")
+set(VERSION_MINOR "3")
 set(VERSION_PATCH "0")
 set(VERSION_COUNT 3)
 set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
@@ -17,6 +17,10 @@
 	find_program(OTOOL_BIN otool)
 endif()
 
+if (${CMAKE_SYSTEM_NAME} MATCHES "Haiku")
+	set(USB_BACKEND_HAIKU TRUE)
+endif()
+
 set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake ${CMAKE_MODULE_PATH})
 
 include(FindPkgConfig)
@@ -28,10 +32,11 @@
 option(BUILD_FUSE "Build fuse mount helper" ON)
 option(BUILD_MTPZ "Build with MTPZ support" ON)
 option(BUILD_PYTHON "Build python module" ON)
+set(BUILD_PYTHON_VERSION "" CACHE STRING "Force specific python version to build")
 option(BUILD_TAGLIB "Build with taglib support" ON)
 
 if (BUILD_PYTHON)
-	find_package (Python COMPONENTS Interpreter Development QUIET)
+	find_package (Python ${BUILD_PYTHON_VERSION} COMPONENTS Interpreter Development QUIET)
 endif()
 
 if (BUILD_SHARED_LIB)
@@ -57,7 +62,9 @@
 endif()
 
 if (PYTHON_FOUND)
-	set(CMAKE_POSITION_INDEPENDENT_CODE ON)
+	if (NOT HAIKU)
+		set(CMAKE_POSITION_INDEPENDENT_CODE ON)
+	endif()
 	find_package(pybind11)
 	if (NOT pybind11_FOUND)
 		set(CMAKE_REQUIRED_INCLUDES ${Python_INCLUDE_DIRS})
@@ -165,6 +172,14 @@
 		mtp/backend/darwin/usb/Exception.cpp
 		mtp/backend/darwin/usb/Interface.cpp
 	)
+elseif (USB_BACKEND_HAIKU)
+	add_definitions(-DUSB_BACKEND_HAIKU)
+	list(APPEND SOURCES
+		mtp/backend/haiku/usb/Context.cpp
+		mtp/backend/haiku/usb/Device.cpp
+		mtp/backend/haiku/usb/DeviceDescriptor.cpp
+	)
+	list(APPEND MTP_LIBRARIES device)
 else()
 	list(APPEND SOURCES
 		mtp/backend/linux/usb/Endpoint.cpp
@@ -230,6 +245,8 @@
 	target_include_directories(${LIB_NAME} PUBLIC mtp/backend/libusb)
 elseif (USB_BACKEND_DARWIN)
 	target_include_directories(${LIB_NAME} PUBLIC mtp/backend/darwin)
+elseif (USB_BACKEND_HAIKU)
+	target_include_directories(${LIB_NAME} PUBLIC mtp/backend/haiku)
 else()
 	target_include_directories(${LIB_NAME} PUBLIC mtp/backend/linux)
 endif()

=== qt/CMakeLists.txt ===
--- 
+++ 
@@ -50,6 +50,7 @@
 	translations/android-file-transfer-linux_it.ts
 	translations/android-file-transfer-linux_nl.ts
 	translations/android-file-transfer-linux_ru.ts
+	translations/android-file-transfer-linux_zh-CN.ts
 )
 
 if (Qt5Widgets_FOUND)

=== debian/changelog ===
android-file-transfer (4.3-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 16:13:27 +1100

android-file-transfer (4.3-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 03:51:02 +0000

android-file-transfer (4.3-1build1) noble; urgency=medium

  * No-change rebuild for readline time64 change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 14 Mar 2024 02:52:26 +0100

android-file-transfer (4.3-1) unstable; urgency=medium

  * New upstream version 4.3
  * Drop patch included in upstream release
  * Do not repack upstream tarball, no longer needed
  * Standards-Version: 4.6.2 (no changes required)

 -- Dylan Aïssi <daissi@debian.org>  Tue, 16 Jan 2024 09:50:15 +0100

android-file-transfer (4.2-2) unstable; urgency=medium

  * Cherry-pick upstream fix for GCC 13 (Closes: 1037572)
  * Drop useless debian/salsa-ci.yml

 -- Dylan Aïssi <daissi@debian.org>  Tue, 25 Jul 2023 11:44:39 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: android-file-transfer
-Maintainer: Dylan Aïssi <daissi@debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Dylan Aïssi <daissi@debian.org>
 Section: misc
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
@@ -9,7 +10,7 @@
                libreadline-dev,
                pkg-config,
                qttools5-dev
-Standards-Version: 4.5.1
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/debian/android-file-transfer
 Vcs-Git: https://salsa.debian.org/debian/android-file-transfer.git
 Homepage: https://whoozle.github.io/android-file-transfer-linux/

## android-file-transfer 4.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,13 +1,25 @@
-cmake_minimum_required(VERSION 3.5)
+cmake_minimum_required(VERSION 3.10)
 project(android-file-transfer)
 
 set (CMAKE_CXX_STANDARD 11)
 
-set(VERSION_MAJOR "4")
-set(VERSION_MINOR "3")
-set(VERSION_PATCH "0")
-set(VERSION_COUNT 3)
-set(VERSION "${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}")
+file(READ ${CMAKE_SOURCE_DIR}/README.md README_MD)
+string(REGEX MATCH "version-([0-9a-fA-F.]+)-" _VERSION ${README_MD})
+set(AFT_BASE_VERSION ${CMAKE_MATCH_1})
+
+find_package(Git)
+execute_process(COMMAND ${GIT_EXECUTABLE}  -C ${CMAKE_SOURCE_DIR} rev-parse --short HEAD
+	OUTPUT_VARIABLE AFT_REVISION
+	OUTPUT_STRIP_TRAILING_WHITESPACE
+	RESULT_VARIABLE GIT_STATUS
+	WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})
+
+if (GIT_STATUS EQUAL 0)
+	set(AFT_VERSION "${AFT_BASE_VERSION}-${AFT_REVISION}")
+else()
+	set(AFT_VERSION "${AFT_BASE_VERSION}-snapshot")
+endif()
+message(STATUS "version: ${AFT_VERSION}, base version: ${AFT_BASE_VERSION}")
 
 message(STATUS "building for ${CMAKE_SYSTEM_NAME}")
 
@@ -46,7 +58,7 @@
 endif()
 
 if (BUILD_FUSE)
-	pkg_check_modules ( FUSE fuse )
+	pkg_check_modules ( FUSE fuse3 )
 endif()
 
 if (BUILD_TAGLIB)
@@ -58,7 +70,7 @@
 
 if (FUSE_FOUND)
 	message(STATUS "fuse found, building mount helper")
-	add_definitions(${FUSE_CFLAGS} -DFUSE_USE_VERSION=26)
+	add_definitions(${FUSE_CFLAGS} -DFUSE_USE_VERSION=35 -DFUSE_DARWIN_ENABLE_EXTENSIONS=0)
 endif()
 
 if (PYTHON_FOUND)
@@ -112,6 +124,7 @@
 	mtp/ptp/DataTypeCode.cpp
 	mtp/ptp/Device.cpp
 	mtp/ptp/DeviceProperty.cpp
+	mtp/ptp/EventCode.cpp
 	mtp/ptp/Messages.cpp
 	mtp/ptp/ObjectFormat.cpp
 	mtp/ptp/ObjectProperty.cpp
@@ -133,17 +146,6 @@
 	mtp/mtpz/TrustedApp.cpp
 )
 
-exec_program(git ARGS describe --tags --match='v*' OUTPUT_VARIABLE AFT_VERSION RETURN_VALUE GIT_STATUS)
-if (GIT_STATUS EQUAL 0)
-	string(REGEX MATCH "v([0-9a-fA-F.]+)-" _VERSION ${AFT_VERSION})
-	set(AFT_BASE_VERSION ${CMAKE_MATCH_1})
-else()
-	file(READ ${CMAKE_SOURCE_DIR}/README.md README_MD)
-	string(REGEX MATCH "version-([0-9a-fA-F.]+)-" _VERSION ${README_MD})
-	set(AFT_BASE_VERSION ${CMAKE_MATCH_1})
-	set(AFT_VERSION "v${AFT_BASE_VERSION}-snapshot")
-endif()
-message(STATUS "version: ${AFT_VERSION}, base version: ${AFT_BASE_VERSION}")
 
 set(VERSION_SRC ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/version.cpp)
 configure_file(mtp/version.cpp.in ${VERSION_SRC})
@@ -216,7 +218,7 @@
 
 if (BUILD_SHARED_LIB)
 	add_library(${LIB_NAME} SHARED ${SOURCES})
-	set_target_properties(${LIB_NAME} PROPERTIES SOVERSION ${VERSION})
+	set_target_properties(${LIB_NAME} PROPERTIES SOVERSION ${AFT_BASE_VERSION})
 	target_link_libraries(${LIB_NAME} PRIVATE ${CMAKE_THREAD_LIBS_INIT} ${MTP_SHARED_LIBRARIES})
 
 	if (USB_BACKEND_LIBUSB)
@@ -257,7 +259,7 @@
 		list(APPEND MACOSX_BUNDLE_LIBS /usr/local/opt/openssl@1.1/lib/libcrypto.1.1.dylib)
 	endif()
 	if (TAGLIB_FOUND)
-		list(APPEND MACOSX_BUNDLE_LIBS /usr/local/opt/taglib/lib/libtag.1.dylib)
+		list(APPEND MACOSX_BUNDLE_LIBS /usr/local/opt/taglib/lib/libtag.2.dylib)
 	endif()
 	if (FUSE_FOUND)
 		list(APPEND MACOSX_BUNDLE_LIBS /usr/local/lib/libosxfuse.2.dylib)

=== cli/CMakeLists.txt ===
--- 
+++ 
@@ -13,7 +13,7 @@
 	set(CMAKE_REQUIRED_LIBRARIES ${Readline_LIBRARY})
 	set(READLINE_TEST_SRC "
 #include <stdio.h>
-#include <readline/readline.h>
+#include <readline.h>
 
 int main(int argc, char **argv) {
 	char *line = readline(\">\");

=== fuse/CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-add_executable(aft-mtp-mount fuse_ll.cpp)
+add_executable(aft-mtp-mount fuse.cpp)
 
 target_link_libraries(aft-mtp-mount ${MTP_LIBRARIES} ${FUSE_LDFLAGS} ${CMAKE_THREAD_LIBS_INIT})
 install(TARGETS aft-mtp-mount RUNTIME DESTINATION bin)

=== qt/CMakeLists.txt ===
--- 
+++ 
@@ -1,12 +1,19 @@
 if(DESIRED_QT_VERSION)
 	if(DESIRED_QT_VERSION MATCHES 4)
 		find_package(Qt4 QUIET)
-	else()
+	elseif(DESIRED_QT_VERSION MATCHES 5)
 		find_package(Qt5Widgets QUIET)
 		find_package(Qt5Network QUIET)
 		find_package(Qt5LinguistTools QUIET)
+	else()
+		find_package(Qt6Widgets QUIET)
+		find_package(Qt6Network QUIET)
+		find_package(Qt6LinguistTools QUIET)
 	endif()
 else()
+	find_package(Qt6Widgets QUIET)
+	find_package(Qt6Network QUIET)
+	find_package(Qt6LinguistTools QUIET)
 	find_package(Qt5Widgets QUIET)
 	find_package(Qt5Network QUIET)
 	find_package(Qt5LinguistTools QUIET)
@@ -53,7 +60,23 @@
 	translations/android-file-transfer-linux_zh-CN.ts
 )
 
-if (Qt5Widgets_FOUND)
+if (Qt6Widgets_FOUND)
+	message(STATUS "Using Qt6")
+	qt6_wrap_cpp(HEADERS_MOC ${HEADERS})
+	qt6_wrap_ui(FORMS_HEADERS ${FORMS})
+
+	qt6_add_translation(QM_FILES ${TS_FILES})
+	set(QM_FILES_XML "")
+	foreach(_QM ${QM_FILES})
+		get_filename_component(_QM ${_QM} NAME)
+		set(QM_FILES_XML "${QM_FILES_XML}<file>${_QM}</file>")
+	endforeach()
+	configure_file(translations/translations.qrc.in translations.qrc)
+
+	qt6_add_resources(RESOURCES android-file-transfer.qrc ${CMAKE_CURRENT_BINARY_DIR}/translations.qrc)
+	include_directories(${Qt6Widgets_INCLUDE_DIRS} ${Qt6Network_INCLUDE_DIRS})
+	set(EXTRA_QT_LINK ${Qt6Widgets_LIBRARIES} ${Qt6Network_LIBRARIES})
+elseif (Qt5Widgets_FOUND)
 	message(STATUS "Using Qt5")
 	qt5_wrap_cpp(HEADERS_MOC ${HEADERS})
 	qt5_wrap_ui(FORMS_HEADERS ${FORMS})
@@ -97,11 +120,10 @@
 
 if (BUILD_QT_UI)
   if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
-	set(MACOSX_BUNDLE_INFO_STRING "${CMAKE_PROJECT_NAME} ${PROJECT_VERSION}")
+	string(TIMESTAMP COPYRIGHT_YEAR "%Y")
 	set(MACOSX_BUNDLE_BUNDLE_VERSION "${AFT_BASE_VERSION}")
-	set(MACOSX_BUNDLE_LONG_VERSION_STRING "${CMAKE_PROJECT_NAME} ${PROJECT_VERSION}")
-	set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${PROJECT_VERSION}")
-	set(MACOSX_BUNDLE_COPYRIGHT "2015-2020 Vladimir Menshakov")
+	set(MACOSX_BUNDLE_SHORT_VERSION_STRING "${AFT_VERSION}")
+	set(MACOSX_BUNDLE_COPYRIGHT "2015-${COPYRIGHT_YEAR} Vladimir Menshakov")
 	set(MACOSX_BUNDLE_ICON_FILE "android-file-transfer.icns")
 	set(MACOSX_BUNDLE_GUI_IDENTIFIER "io.github.whoozle.android-file-transfer-linux")
 	set(MACOSX_BUNDLE_BUNDLE_NAME "${CMAKE_PROJECT_NAME}")

=== python/example/requirements.txt ===
pyinquirer

=== debian/changelog ===
android-file-transfer (4.5-2) unstable; urgency=medium

  * Upload to unstable.

 -- Dylan Aïssi <daissi@debian.org>  Mon, 11 Aug 2025 09:10:25 +0200

android-file-transfer (4.5-1) experimental; urgency=medium

  * New upstream version 4.5
  * Switch from fuse to fuse3 in Build-Deps (Closes: 1084450).
  * Switch from pkg-config to pkgconf in Build-Deps.
  * Add libssl-dev in Build-Deps to enable MTPZ support.
  * Add libtag-dev in Build-Deps to enable taglib support.
  * Add libmagic-dev in Build-Deps.
  * Standards-Version: 4.7.2 (no changes required).
  * Add debian/salsa-ci.yml.
  * Switch to Qt6.
  * Use execute_after_dh_auto_install.

 -- Dylan Aïssi <daissi@debian.org>  Tue, 27 May 2025 23:29:46 +0200

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,18 @@
 Source: android-file-transfer
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Dylan Aïssi <daissi@debian.org>
+Maintainer: Dylan Aïssi <daissi@debian.org>
 Section: misc
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
                cmake,
-               qtbase5-dev,
-               libfuse-dev,
+               qt6-base-dev,
+               libfuse3-dev,
+               libmagic-dev,
                libreadline-dev,
-               pkg-config,
-               qttools5-dev
-Standards-Version: 4.6.2
+               libssl-dev,
+               libtag-dev,
+               pkgconf,
+               qt6-tools-dev
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/debian/android-file-transfer
 Vcs-Git: https://salsa.debian.org/debian/android-file-transfer.git
 Homepage: https://whoozle.github.io/android-file-transfer-linux/

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

execute_after_dh_auto_install:
	# Removing unused files
	rm -f debian/android-file-transfer/usr/lib/libmtp-ng-static.a
	find debian/android-file-transfer/ -type d -empty -delete

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/android-file-transfer-linux-$1\.tar\.gz/ \
  https://github.com/whoozle/android-file-transfer-linux/tags .*/v?(\d\S+)\.tar\.gz
